#!/bin/bash

BYTES="\xb8\x01\x00\x00\x00\xc3"
BYTES_LEN=$(echo -ne "${BYTES}" | wc -c)

if [ -z ${1} ]; then
	echo "Enter Gowin root directory (for ex: /opt/Gowin_V1.9.8.03):"
	read GOWIN_DIR
else
	GOWIN_DIR=${1}
fi

for file in $(find $GOWIN_DIR -executable -type f -not -name "*.bak"); do
	head -c 4 "${file}" | grep ^.ELF >/dev/null 2>&1 || continue
	SECT_HEADER=$(objdump -h "$file" | grep [.]text)
	LMA_BASE=0x$(echo ${SECT_HEADER} | awk '{print $5}')
	FILE_OFS=0x$(echo ${SECT_HEADER} | awk '{print $6}')
	OFFSETS=$(objdump -tC "$file" 2>/dev/null | grep GWLIC::digest_verify | cut -f1 -d' ')
	[ -z "${OFFSETS}" ] && continue
	[ -e "${file}.bak" ] || cp -v "${file}" "${file}.bak"
	for ofs in ${OFFSETS}; do
		dst_offs=$((${FILE_OFS} + 0x${ofs} - ${LMA_BASE}))
		echo "Patching ${file} at $(printf "0x%X" ${dst_offs}) offset"
		echo -ne $BYTES | dd of=$file count=${BYTES_LEN} bs=1 seek=${dst_offs} conv=notrunc 2>/dev/null
	done
done
